from Base import PlatformImplementation
from Products.CMFMetadata import Configuration

from Products.CMFCore.ActionInformation import ActionInformation
from Products.CMFCore.ActionProviderBase import ActionProviderBase
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.interfaces import portal_actions, portal_metadata
from Products.CMFCore.utils import UniqueObject
from Products.CMFCore import CMFCorePermissions

class CMF(PlatformImplementation):
    
    IActionProvider = portal_actions.ActionProvider
    IPortalMetadata = portal_metadata.portal_metadata

    def getContentTypeNames(self, ctx):
        pt = getToolByName(ctx, 'portal_types')
        return pt.objectIds()

    def getContentType(self, content):
        return content.getPortalTypeName()
    
    if Configuration.pMetadataView is None:
        Configuration.pMetadataView = CMFCorePermissions.View
    if Configuration.pMetadataEdit is None:
        Configuration.pMetadataEdit = CMFCorePermissions.ModifyPortalContent
    if Configuration.pMetadataManage is None:
        Configuration.pMetadataManage = CMFCorePermissions.ManagePortal

    index_expression_template = "python: object.portal_metadata.getMetdatata(object)['%s']['%s']"

    UniqueObject = UniqueObject
