from Base import PlatformImplementation
from Products.CMFMetadata import Configuration
from Acquisition import aq_inner, aq_base, aq_get
from OFS.ObjectManager import UNIQUE
from Interface import Interface
from ExtensionClass import Base

_allowed_content_types = []
    
SilvaToolMap = {
    'portal_catalog':'service_catalog',
    'portal_annotations':'service_annotations',
    'portal_metadata':'service_metadata'
    }

class ImmutableId(Base):

    """ Base class for objects which cannot be renamed.
    """
    def _setId(self, id):

        """ Never allow renaming!
        """
        if id != self.getId():
            raise MessageDialog(
                title='Invalid Id',
                message='Cannot change the id of this object',
                action ='./manage_main',)

class UniqueObject (ImmutableId):

    """ Base class for objects which cannot be "overridden" / shadowed.
    """
    __replaceable__ = UNIQUE


class Silva(PlatformImplementation):

    class IActionProvider(Interface): pass
    class IPortalMetadata(Interface): pass

    def getToolByName(self, ctx, service_name, default=_marker):
        try:
            silva_name = SilvaToolMap[service_name]
        except KeyError, e:
            raise CompatibilityException(str(e))

        try:
            tool = aq_get(ctx, silva_name, default, 1)
        except AttributeError:
            if default is _marker:
                raise
            return default
        
        if tool is _marker:
            raise AttributeError(silva_name)
        
        return tool

    def registerTypeForMetadata(self, type_name):
        global _allowed_content_types
        _allowed_content_types.append(type_name)

    def getContentTypeNames(self, ctx):
        global _allowed_content_types
        return tuple(_allowed_content_types)

    index_expression_template = "python: object.service_metadata.getMetadata(object)['%s']['%s']"


    UniqueObject = UnqiueObject


    from Products.Silva import SilvaPermissions
    if Configuration.pMetadataView is None:    
        Configuration.pMetadataView = SilvaPermissions.View
    if Configuration.pMetadataEdit is None:        
        Configuration.pMetadataEdit = SilvaPermissions.ChangeSilvaContent
    if Configuration.pMetadataManage is None:        
        Configuration.pMetadataManage = SilvaPermissions.ViewManagementScreens
